<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "app_setup".
 *
 * @property int $id
 * @property string $shopify_shop
 * @property string $shopify_token
 * @property string $shopify_code
 * @property int $shopify_status
 * @property string $api_client_id
 * @property string $created_at
 */
class AppSetup extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'app_setup';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['shopify_shop', 'shopify_token', 'shopify_code', 'shopify_status', 'api_client_id', 'created_at'], 'required'],
            [['shopify_shop', 'shopify_token', 'shopify_code'], 'string'],
            [['created_at'], 'safe'],
            [['shopify_status'], 'string', 'max' => 1],
            [['api_client_id'], 'string', 'max' => 50],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'shopify_shop' => 'Shopify Shop',
            'shopify_token' => 'Shopify Token',
            'shopify_code' => 'Shopify Code',
            'shopify_status' => 'Shopify Status',
            'api_client_id' => 'Api Client ID',
            'created_at' => 'Created At',
        ];
    }
}
